% Find roots of polynomial using Newton's method
clear all;close all;clc;

Ntrials=1000
NTrials=input('NTrials=');
StepSize=0.1;
StepSize=input('StepSize=');

c=[':.b'; ':sr'; ':og'; ':pm'; ':.k'];
A=[1+j 0 0 0; 0 2-j/2 0 0; 0 0 3 0; 0 0 0 4-j]; %place roots on diag
P=poly(A);

P=[1 0 0 0 -1 -1];
P1=polyder(P);
R=roots(P);
R1=roots(P1);
sprintf('Roots: %d, %d, %d, %d\n\n',R);
sprintf('Roots: %d, %d, %d, %d\n\n',R1);

%Plot the roots of Num and Denom
figure(1);
Fp=plot(R,'ob','MarkerSize',10); hold on; grid on;
plot(R1,'xr','MarkerSize',10);
axis square

% Perhaps this is too difficult to implement?
%zviz W=R

y=[]; x=1+eps*j;
  while x~=0;
%clc;

%Now apply Newton method;
%Define starting value
%x0=input('starting value=');
%n=1;x(1)=x0+1e-6j;
x=2*((rand(1)-.5)+(rand(1)-.5)*j);
%x=conj(x);

y=[];
for n=1:Ntrials
y(n)=x; %save sequence
x = x - StepSize*polyval(P,x)./polyval(P1,x);
%Plot results
%plot(y,c(rn,:),'MarkerSize',2); hold on; grid on;
%plot(1:length(R),R,'x','MarkerSize',5);hold on

  end %for

  rn=ceil(abs(y(end)));   %must be a positive integer

  plot(y,c(rn,:),'MarkerSize',2); hold on; grid on;
  xlabel('\Re x'); ylabel('\Im x');
  xlim([-2 2]);ylim([-1.5 1.5]);
 title(sprintf('NewtonRoots: Step=%g',StepSize) )
  
%drawnow;%hold off;
disp(sprintf('y(end)=%g\n',real(y(end))));drawnow;
pause(0.2); %input('Any key to continue');
  end %while
